/***************************************************************************
                          car.cpp  -  description
                             -------------------
    begin                : Mon Jan 3 2000
    copyright            : (C) 2000 by Perdig
    email                : perdig@linuxbr.com.br

    $Id: car.c,v 1.4 2000/11/25 14:48:53 perdig Exp $
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "car.h"
#include "graphics.h"
#include "game.h"
#include "ai.h"
#include "config.h"

#ifdef USE_SOUND
#include "sound.h"
#endif

//#define OLD_INTERSECT

carStruct blue_car;
extern Image red_carImg[4];
extern int SPRITE_SIZE;
smoke_struct smoke;
bool crashed;

extern int mapResult;
extern aiStruct AI;
extern mapStruct *map;
extern bool ENDMAP;

int check_player_car();
bool fitsY(carStruct *Car);
bool fitsX(carStruct *Car);


bool changeDir(carStruct *Car, mapStruct *Map, int direction) {
	Car->toGoDir = direction;
	Car->aiguess = -1;
	return true;
}

bool turn(carStruct *Car, mapStruct *Map) {
	if (Car->aiguess >= 0) {
		if (isClean(Map, Car, Car->aiguess, 0)) {
			Car->direction = Car->aiguess;
			Car->toGoDir = Car->direction;
			Car->aiguess = -1;
			return true;
		}
	}
	if (Car->toGoDir != Car->direction) {
		// Wants to turn
		// Check if it should
		if (isClean(Map, Car, Car->toGoDir, 0)) { 
			Car->direction = Car->toGoDir;
		}
	}
	return true;
}

bool carAI(carStruct *Car, mapStruct *Map) {
	int a, tx, ty;
	if (Car->ai >= 2)
		return false;
	if (fits(Car) && Car->ai <= 0) {
		for (a = 0; a < 5; a++) {
			if (a == 4) {
				// Well, I give up! Turn back
				changeDir(Car, Map, (Car->direction==1) ? 3 : abs(Car->direction -2));
				break;
			}
			if (abs(a - Car->direction) != 2 && isClean(Map, Car, a, 0)) {
				changeDir(Car, Map, a);
				break;
			}
		}
	} else {
		tx = Car->x / SPRITE_SIZE;
		ty = Car->y / SPRITE_SIZE;
		switch (Car->direction) {
			case UP:
				if (passable(tx, ty-1)) {
					changeDir(Car, Map, LEFT);
					Car->aiguess = UP;
				} else if (passable(tx+1, ty-1)) {
					changeDir(Car, Map, RIGHT);
					Car->aiguess = UP;
				} else if (Car->ai<=0) {
					changeDir(Car, Map, RIGHT);
				}
				break;
			case RIGHT:
				if (passable(tx+1, ty)) {
					changeDir(Car, Map, UP);
					Car->aiguess = RIGHT;
				} else if (passable(tx+1, ty+1)) {
					changeDir(Car, Map, DOWN);
					Car->aiguess = RIGHT;
				} else if (Car->ai<=0) {
					changeDir(Car, Map, DOWN);
				}
				break;
			case DOWN:
				if (passable(tx, ty+1)) {
					changeDir(Car, Map, LEFT);
					Car->aiguess = DOWN;
				} else if (passable(tx+1, ty+1)) {
					changeDir(Car, Map, RIGHT);
					Car->aiguess = DOWN;
				} else if (Car->ai<=0) {
					changeDir(Car, Map, LEFT);
				}
				break;
			case LEFT:
				if (passable(tx-1, ty)) {
					changeDir(Car, Map, UP);
					Car->aiguess = LEFT;
				} else if (passable(tx-1, ty+1)) {
					changeDir(Car, Map, DOWN);
					Car->aiguess = LEFT;
				} else if (Car->ai<=0) {
					changeDir(Car, Map, UP);
				}
				break;
		}
	}
	return true;
}
		
	/* OLD STUFF (turn and carAI)
	static int a = 0;
	int oldDir;
	bool test;
	int oldX, oldY;
	static bool tryOld = true;
	// Check if it wants to turn
	if (Car->toGoDir != Car->direction) {
		if (isClean(Map, Car, Car->toGoDir, 0) && (fits(Car) || !restrictedArea(Map, Car)))
				// Turns!
				Car->direction = Car->toGoDir;
		// Check if it is clean to turn and if it fits in the sprite
		if (Car->toGoDir == LEFT || Car->toGoDir == RIGHT) {
			if (isClean(Map, Car, Car->toGoDir, 0) && (fitsY(Car) || !restrictedArea(Map, Car)))
				// Turns!
				Car->direction = Car->toGoDir;
		} else {
			if (isClean(Map, Car, Car->toGoDir, 0) && (fitsX(Car) || !restrictedArea(Map, Car)))
				// Turns!
				Car->direction = Car->toGoDir;
		}
	}
	// Check if it is clean to go in that direction
	if (!isClean(Map, Car, Car->direction, 0) && fits(Car)) {
		// It can't stop moving!!
		a = (a == 3) ? a = 0 : a + 1;
		if ((a == (Car->direction + 2) || a == (Car->direction - 2)) && tryOld) {
			tryOld = false;
			a = (a == 3) ? a = 0 : a + 1;
		}
		changeDir(Car, Map, a);
		return carAI(Car, Map);
	}
	tryOld = true;
	*/

void moveXY(int *x, int *y, int dir, int offset) {
	switch (dir) {
		case UP:
			*y-=offset;
			break;
		case RIGHT:
			*x+=offset;
			break;
		case DOWN:
			*y+=offset;
			break;
		case LEFT:
			*x-=offset;
			break;
	}
}

bool move(carStruct *Car, mapStruct *Map) {
	int a;
	if (check_player_car()!=0)
		return false;
	for (a = 0; a < Car->vel; a++) {
		turn(Car, Map);
		if (Car->ai >= 0 && check_player_car()!=0)
			return false;
		if (isClean(Map, Car, Car->direction, 0)) {
			// MOVE
			moveXY(&Car->x, &Car->y, Car->direction, 1);
		} else {
			// EXIT
			carAI(Car, Map);
			return false;
		}
	}
	return true;
}
	/* OLD move STUFF
	// Check if it can continue moving
	if (!isClean(Map, Car, Car->direction, 0)  && fits(Car)) {
		return false;
	}
	// Move
	switch (Car->direction) {
		case UP:
  		// Move car
			Car->y -= Car->vel;
			break;
		case RIGHT:
			// Move car
			Car->x += Car->vel;
			break;
		case DOWN:
			// Move car
			Car->y += Car->vel;
			break;
		case LEFT:
			// Move car
			Car->x -= Car->vel;
			break;
		default:
			break;
	}
	return true;
	*/

bool fitsX(carStruct *Car) {
	carStruct car;
	car = *Car;
	car.y = toMap(toTile(Car->y));
	return fits(&car);
}

bool fitsY(carStruct *Car) {
	carStruct car;
	car = *Car;
	car.x = toMap(toTile(Car->x));
	return fits(&car);
}

bool fits(carStruct *Car) {
	int a, b;
	a = toTile(Car->x);
	a = toMap(a);
	b = toTile(Car->y);
	b = toMap(b);
	a -= Car->x;
	b -= Car->y;
	if (abs(a) < Car->vel && abs(b) < Car->vel) {
		Car->x += a;
		Car->y += b;
		return true;
	}	else
		return false;
}

bool check(carStruct *Car, aiStruct *AI, mapStruct *Map) {
	int a;
	// Check is its a flag
		if (Map->data[(toTile(Car->y)*Map->width) + toTile(Car->x)] == FLAG) {
			getFlag(toTile(Car->x), toTile(Car->y));
			#ifdef USE_SOUND
			play_sound (SOUND_GETFLAG);
			#endif
		}

#ifdef PLAYABLE	
	// Check if got by a enemy
	for (a = 0; a < AI->number; a++) {
		if (AI->order[a] != CONFUSED && intersect(Car, &AI->bot[a])) {
			ldbg("AI x: %d\ty: %d", AI->bot[a].x, AI->bot[a].y);
			ldbg("Car x: %d\ty: %d", Car->x, Car->y);
			crashed = true;
			#ifdef USE_SOUND
			play_sound(SOUND_CRASH);
			#endif
			return true;
		}
	}

	// Check if its in a pit pit
	if (Map->data[(toTile(Car->y)*Map->width) + toTile(Car->x)] == PIT) {
		crashed = true;
#ifdef USE_SOUND
		play_sound(SOUND_CRASH);
#endif
		return true;
	}
#endif

	return false;

}

bool intersect(carStruct *Car, carStruct *AI) {
#ifdef OLD_INTERSECT
	return abs(AI->x - Car->x) < SPRITE_SIZE && abs(AI->y - Car->y) < SPRITE_SIZE;
#else
	return (toTile(Car->x) == toTile(AI->x)) && (toTile(Car->y) == toTile(AI->y));
#endif
}

void carCheck(aiStruct *ai, mapStruct *map) {
	int a, b, value;
	// Now check the enemys
	for (a = 0; a < ai->number; a++) {
		value = map->data[toTile(ai->bot[a].y)*map->width+toTile(ai->bot[a].x)];
		// If just come out of confusion
		if (ai->order[a] == CONFUSED && ai->data[a] != 0) {
			// Already confused. Don't mess with it
			continue;
		} else if (ai->order[a] == CONFUSED && ai->data[a] == 0) {
			// Just got out of confusion -> Half second to think about life
			ai->order[a] = WANDER;
			ai->data[a] = -(REST_TIME);
			ai->bot[a].img[ai->bot[a].direction] = &red_carImg[ai->bot[a].direction];
		 	changeDir(&ai->bot[a], map, random() % 4);
			carAI(&ai->bot[a], map);
			continue;
		} else if (ai->data[a] < 0) {
			// data < 0 -> Ai unvulnerable
			// Increase the data
			ai->data[a]++;
			continue;
		}
		// Now check if it was got by another enemy or by smoke
		// Check if the car hits another
		// This really needs to be improved
		for (b = 0; b < ai->number; b++) {
			if (a == b)
				continue;
			if (intersect(&ai->bot[a], &ai->bot[b])) {
//				dbg("Confusing car %d (crashed)", a);
				ai->order[a] = ai->order[b] = CONFUSED;
				// Rest for 2 seconds
				ai->data[a] = ai->data[b] = (CONFUSED_TIME);
			}
		}
		// Now check for smoke
		for (b = 0; b < SMOKE_NUM; b++) {
			if (smoke.x[b] < 0 || smoke.y[b] < 0)
				continue;
			// Car must be really got by smoke:
			// abs(smoke.x - car.x) <= car.vel
			if (abs(smoke.x[b] - ai->bot[a].x) < ai->bot[a].vel && abs(smoke.y[b] - ai->bot[a].y) < ai->bot[a].vel) {
//				dbg("Confusing car %d (smoked)", a);
				ai->order[a] = CONFUSED;
				// Rest for 2 seconds
				ai->data[a] = (CONFUSED_TIME);
			}				
		}
		// Now check for pit pits (smart AIS won't need to check for this)
		if (value == PIT) {
				ai->order[a] = CONFUSED;
				// Rest for 2 seconds
				ai->data[a] = (CONFUSED_TIME);
		}				
	}

	// Now update the smokes
	for (b = 0; b < SMOKE_NUM; b++) {
		if (smoke.x[b] >= 0 && smoke.y[b] >= 0)
			smoke.left[b]--;
   	if (smoke.left[b] < 0) {
			smoke.x[b] = -1;
			smoke.y[b] = -1;
		}
	}
}

bool restrictedArea(mapStruct *Map, carStruct *Car) {
	// Returns true if the area is restricted (must fit to make a turn)
	// Check if turning up/down or left/right (never restricted)
	int x, y;
	x = toTile(Car->x);
	y = toTile(Car->y);
	if (abs(Car->direction - Car->toGoDir) == 2)
		return false;
  //if (isClean(Map, Car, Car->direction, -1) && isClean(Map, Car, Car->toGoDir, -1) && isClean(Map, Car, Car->toGoDir, 0))
	//	return false;
	return true;
}

int check_player_car() {
  if (check(&blue_car, &AI, map) || blue_car.vel <= 0) {
		// LOST THE GAME !!!
  	mapResult = RESULT_LOSE;
		ENDMAP = true;
		ldbg("Ended map... lost!");
		return -1;
  }
  if (map->flagLeft <= 0 && map->flagNum != 0) {
		// WON THE GAME
		mapResult = RESULT_WIN;
		ldbg("Ended map... won!");
		ENDMAP = true;
		return 1;
	}
	return 0;
}
