/***************************************************************************
                           sound.h  -  description
                             -------------------
    begin                : Sun Jul 23 2000
    copyright            : (C) 2000 by Claudio Matsuoka
    email                : claudio@helllabs.org

    $Id: sound.h,v 1.6 2000/11/22 22:43:25 claudio2 Exp $
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef _XRALLY_SOUND_H
#define _XRALLY_SOUND_H

#include <stdio.h>

/* Driver API */

struct sound_driver {
	char *desc;
	int (*init)(void);
	void (*deinit)(void);
	void (*dump_buffer)(void);
};

//extern struct sound_driver *snddev;
extern struct sound_driver sound_oss;
extern struct sound_driver sound_dummy;


/* Player API */

void	sound_start	(void);
void	sound_stop	(void);
void	sound_select	(int);
void	sound_play	(int, int, int);
int	sound_init	(void);
void	sound_deinit	(void);
void	sound_volume	(int);
int	sound_load	(char *);
void	sound_unload	(void);
void	sound_changevol	(int);
void	sound_switch	(void);
int	sound_playing	(void);

#endif	/* _XRALLY_SOUND_H */
