/***************************************************************************
                         sound_oss.c  -  description
                             -------------------
    begin                : Sun Jul 23 2000
    copyright            : (C) 2000 by Claudio Matsuoka
    email                : claudio@helllabs.org

    $Id: sound_oss.c,v 1.3 2000/11/22 22:43:25 claudio2 Exp $
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <sys/soundcard.h>
#include "config.h"
#include "soundplayer.h"

#define FRAGNUM		(32 - 1)
#define FRAGSIZE	(8)

static int oss_init_sound (void);
static void oss_close_sound (void);
static void dump_buffer (void);

struct sound_driver sound_oss = {
	"OSS /dev/dsp sound output",
	oss_init_sound,
	oss_close_sound,
	dump_buffer
};

static int audio_fd;


static int oss_init_sound ()
{
	int i;
	audio_buf_info info;

	if ((audio_fd = open ("/dev/dsp", O_WRONLY)) == -1)
		return -1;

	printf ("sound_oss: OSS support by claudio@helllabs.org\n");

	/* Set sound device to 16 bit, 22 kHz mono */

	i = (FRAGNUM << 16 | FRAGSIZE);
	ioctl (audio_fd, SNDCTL_DSP_SETFRAGMENT, &i);

	ioctl (audio_fd, SNDCTL_DSP_GETOSPACE, &info);
	printf ("sound_oss: %d fragments of %d bytes\n",
		info.fragstotal, info.fragsize);

	i = AFMT_S16_NE;
	ioctl (audio_fd, SNDCTL_DSP_SETFMT, &i);
	i = 0;
	ioctl (audio_fd, SNDCTL_DSP_STEREO, &i);
	i = 22050;
	ioctl (audio_fd, SNDCTL_DSP_SPEED, &i);

	return 0;
}


static void oss_close_sound ()
{
	ioctl (audio_fd, SNDCTL_DSP_SYNC);
	close (audio_fd);
}


static void dump_buffer ()
{
	int i = BUFFER_SIZE << 1, j;
	short *b = snd_buffer;

	do {
		if ((j = write (audio_fd, b, i)) > 0) {
			i -= j;
			b += j;
		}
	} while (i);
}

